window.watchface = {};
var canvas, context;
var gImage;
var WIDTH, HEIGHT;
var frameRate = 5;
var refreshCount = 0;
var battery;
var currentFrame;
var TIMELINE_MAX_VALUE = 24 * 60 * 60 * frameRate;
var dayOfWeek = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
var dayOfWeekFull = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
var monthStr = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
var monthStrFull = ["January", "Febuary", "March", "April", "May", "Jun", "July", "August", "September", "October", "November", "December"];
var maximumDays = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
var stepCount = 0;
var previousDate = 0

var Background1ButtonArea = [0, 0, 360, 360];
var Background1ButtonIndex = 0;
var Background1ButtonImage = ["whiteana.png"];
window.watchface.imgwhiteanapng = new Image();
    window.watchface.imgwhiteanapng.src = "whiteana.png";
var Digitalclock1BitmapStrImages = [];
var Digitalclock1BitmapStrKey = ["am", "pm"];
var Digitalclock1BitmapStr = ["", ""];
var Digitalclock1Images = [];
var Digitalclock1Bitmap = ["", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "1.png", "2.png", "3.png", "4.png", "5.png", "6.png", "7.png", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""];
window.watchface.imghourspng = new Image();
    window.watchface.imghourspng.src = "hours.png";
window.watchface.imgminutespng = new Image();
    window.watchface.imgminutespng.src = "minutes.png";
window.watchface.imgsec1png = new Image();
    window.watchface.imgsec1png.src = "sec1.png";

window.requestAnimationFrame ||
    window.webkitRequestAnimationFrame ||
    window.mozRequestAnimationFrame ||
    window.oRequestAnimationFrame ||
    window.msRequestAnimationFrame ||
    function (/* function */ callback) {
        'use strict';
        window.setTimeout(callback, 1000 / frameRate);
    };

function getDate() {
    'use strict';

    var date;
    try {
        date = tizen.time.getCurrentDateTime();
    } catch (err) {
        console.error('Error: ', err.message);
        date = new Date();
    }

    return date;
}

function findByValue(isTime, array, value) {
    if (isTime) {
        if (value === TIMELINE_MAX_VALUE) {
            value = 0;
        }

        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] > value) {
                return true;
            }
        }
    } else {
        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] >= value) {
                return true;
            }
        }
    }

    return false;
}

function refresh() {
    'use strict';
    //Erase the previous time
    context.clearRect(0, 0, context.canvas.width, context.canvas.height);

    //Import the current time
    var date = getDate();
    if (previousDate === 0) previousDate = date;
    if (previousDate != date) {
        previousDate = date;
        //webapi.pedometer.prevSteps = webapi.pedometer.steps;
        //webapi.pedometer.steps = 0;
    }
    var hours = date.getHours();
    var minutes = date.getMinutes();
    var seconds = date.getSeconds();
    var hour = hours + minutes / 60;
    var minute = minutes + seconds / 60;
    var milliseconds = seconds + date.getMilliseconds()/1000.0;
    var frame = parseInt(date.getMilliseconds()/(1000/frameRate));
    var angle;
    var text;
    var extent;
    var nextX;

    hours = hours > 12 ? hours - 12 : hours;
    currentFrame = (date.getHours() * frameRate * 60 * 60) + (minutes * frameRate * 60) + (seconds * frameRate) + frame;
    context.save();

    gImage.src = '' + Background1ButtonImage[Background1ButtonIndex];
    context.drawImage(window.watchface.imgwhiteanapng, 0, 0, 360, 360);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "28px furore";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#000000";
    text = date.getDate();
    context.fillText(text, 83, 239);
    context.restore();
    context.save();

    var Animation_1= ["top01 - Copy (2).png", "top01 - Copy (3).png", "top01 - Copy.png", "top01.png", "top02 - Copy (2).png", "top02 - Copy (3).png", "top02 - Copy.png", "top02.png", "top03 - Copy (2).png", "top03 - Copy (3).png", "top03 - Copy.png", "top03.png", "top04 - Copy (2).png", "top04 - Copy (3).png", "top04 - Copy.png", "top04.png"];
    gImage.src = '' + Animation_1[refreshCount%16];
    context.drawImage(gImage, 0, 0, 360, 360);
    context.restore();
    context.save();

    text = date.getDay();
    {
        var width = 0;
        var charImage;
        var i, j, strChar;
        var tokens = text.split(" ");
        var path;
        var paths = [];
        var isWord;
    
        for (i = 0; i<tokens.length; i++) {
            isWord = false;
            for (j = 0; j<Digitalclock1BitmapStr.length; j++) {
                if (tokens[i] === Digitalclock1BitmapStrKey[j]) {
                    charImage = Digitalclock1BitmapStrImages[j];
                    width += charImage.width;
                    paths.push(charImage);
                    isWord = true;
                }
            }
    
            if (!isWord) {
                for (j = 0; j<tokens[i].length; j++) {
                    strChar = tokens[i].charCodeAt(j);
                    if (strChar >= 0x20 && strChar <= 0x7E) {
                        if (Digitalclock1Bitmap[strChar - 0x20] !== "") {
                            charImage = Digitalclock1Images[strChar - 0x20];
                            width += charImage.width;
                            paths.push(charImage);
                        }
                    }
                }
            }
        }
    
        var startX = 180 - width/2;
        for (i = 0; i<paths.length; i++) {
            charImage = paths[i];
            context.drawImage(charImage, startX, 180 - charImage.height/2, charImage.width, charImage.height);
            startX += charImage.width;
        }
    }

    angle = (0.000000 + ((720.000000 - 0.000000) * ((hour - 0.000000) / (24.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    context.drawImage(window.watchface.imghourspng, -180, -180, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((minute - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    context.drawImage(window.watchface.imgminutespng, -180, -180, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((milliseconds - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    context.drawImage(window.watchface.imgsec1png, -180, -180, 360, 360);
    context.restore();
    context.save();

    context.restore();
    window.requestAnimationFrame(refresh);
    refreshCount++;
}

window.onload = function () {
    'use strict';
    canvas = document.getElementById('clock');
    console.log('onload called');
    context = canvas.getContext('2d');

    canvas.width = document.width;
    canvas.height = document.height;

    WIDTH = document.width;
    HEIGHT = document.height;

    gImage = new Image();

    battery = navigator.battery || navigator.webkitBattery || navigator.mozBattery;

    //add eventListener for tizenhwkey
    window.addEventListener('tizenhwkey', function (e) {
        if (e.keyName == 'back') {
            try {
                tizen.application.getCurrentApplication().exit();
            } catch (err) {
                console.log('Error: ', err.message);
            }
        }
    });

    window.requestAnimationFrame(refresh);

    var i;
    for (i = 0; i<95; i++) {
        if (Digitalclock1Bitmap[i] !== "") {
            Digitalclock1Images[i] = new Image();
            Digitalclock1Images[i].src = "res/fonts/bitmap_0/" + Digitalclock1Bitmap[i];
        }
    }
    for (i = 0; i<2; i++) {
        if (Digitalclock1BitmapStr[i] !== "") {
            Digitalclock1BitmapStrImages[i] = new Image();
            Digitalclock1BitmapStrImages[i].src = "res/fonts/bitmap_0/" + Digitalclock1BitmapStr[i];
        }
    }
    window.addEventListener('touchstart', function (e) {
        if (e.changedTouches[0].clientX >= Background1ButtonArea[0] && e.changedTouches[0].clientX < Background1ButtonArea[2] && e.changedTouches[0].clientY >= Background1ButtonArea[1] && e.changedTouches[0].clientY < Background1ButtonArea[3]) {
            Background1ButtonIndex++;
            if (Background1ButtonIndex >= Background1ButtonImage.length) {
                Background1ButtonIndex = 0;
            }
        }
    });
};
